// Dispatcher.h: interface for the CDispatcher class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DISPATCHER_H__CDC23DC7_91F8_491E_8A88_435A74EC4D32__INCLUDED_)
#define AFX_DISPATCHER_H__CDC23DC7_91F8_491E_8A88_435A74EC4D32__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TarmacGlobals.h"

#include "Profiler.h"
class CProfiler;

#include "CodeCache.h"

class CDispatcher
{
public:
	void attemptDispatch(uint32 address);
	void executeRecompiledCode(uint32 address);
	CDispatcher();
	virtual ~CDispatcher();

private:
	CProfiler* profiler;
};

#endif // !defined(AFX_DISPATCHER_H__CDC23DC7_91F8_491E_8A88_435A74EC4D32__INCLUDED_)
