// TestMemory.h: interface for the TestMemory class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TESTMEMORY_H__90003430_5EFD_4EDF_AF5F_0C8715EEE53C__INCLUDED_)
#define AFX_TESTMEMORY_H__90003430_5EFD_4EDF_AF5F_0C8715EEE53C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TarmacGlobals.h"

class CTestMemory  
{
public:
	BOOL loadIntoMemory(CString fileName, uint32 address, uint32 numberOfBytes);
	BOOL writeByte(uint32 address, uint8 value);
	BOOL writeWord(uint32 address, uint32 value);
	BOOL readByte(uint32 address, uint8& location);
	BOOL readWord(uint32 address, uint32& location);
	
	CTestMemory(uint32 aSize);
	virtual ~CTestMemory();

private:
	uint32 size;
	uint8* memory;
};

#endif // !defined(AFX_TESTMEMORY_H__90003430_5EFD_4EDF_AF5F_0C8715EEE53C__INCLUDED_)
